## aquamarine 0.9.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)

file(READ "${CMAKE_SOURCE_DIR}/VERSION" VER_RAW)
string(STRIP ${VER_RAW} AQUAMARINE_VERSION)

add_compile_definitions(AQUAMARINE_VERSION="${AQUAMARINE_VERSION}")

project(
  aquamarine
  VERSION ${AQUAMARINE_VERSION}
  DESCRIPTION "A very light linux rendering backend library")

include(CTest)
include(CheckIncludeFile)
include(GNUInstallDirs)

set(PREFIX ${CMAKE_INSTALL_PREFIX})
set(INCLUDE ${CMAKE_INSTALL_FULL_INCLUDEDIR})
set(LIBDIR ${CMAKE_INSTALL_FULL_LIBDIR})

find_package(PkgConfig REQUIRED)
find_package(OpenGL REQUIRED COMPONENTS "GLES3")
find_package(hyprwayland-scanner 0.4.0 REQUIRED)
pkg_check_modules(
  deps
  REQUIRED
  IMPORTED_TARGET
  libseat>=0.8.0
  libinput>=1.26.0
  wayland-client
  wayland-protocols
  hyprutils>=0.8.0
  pixman-1
  libdrm
  gbm
  libudev
  libdisplay-info
  hwdata)

configure_file(aquamarine.pc.in aquamarine.pc @ONLY)

set(CMAKE_CXX_STANDARD 23)
add_compile_options(
  -Wall
  -Wextra
  -Wno-unused-parameter
  -Wno-unused-value
  -Wno-missing-field-initializers
  -Wpedantic)
set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)

if(CMAKE_BUILD_TYPE MATCHES Debug OR CMAKE_BUILD_TYPE MATCHES DEBUG)
  message(STATUS "Configuring aquamarine in Debug")
  add_compile_definitions(AQUAMARINE_DEBUG)
else()
  add_compile_options(-O3)
  message(STATUS "Configuring aquamarine in Release")
endif()

file(GLOB_RECURSE SRCFILES CONFIGURE_DEPENDS "src/*.cpp" "include/*.hpp")
file(GLOB_RECURSE PUBLIC_HEADERS CONFIGURE_DEPENDS "include/*.hpp")

add_library(aquamarine SHARED ${SRCFILES})
target_include_directories(
  aquamarine
  PUBLIC "./include"
  PRIVATE "./src" "./src/include" "./protocols" "${CMAKE_BINARY_DIR}")
set_target_properties(aquamarine PROPERTIES VERSION ${AQUAMARINE_VERSION}
                                            SOVERSION 8)
target_link_libraries(aquamarine OpenGL::EGL OpenGL::OpenGL PkgConfig::deps)

check_include_file("sys/timerfd.h" HAS_TIMERFD)
pkg_check_modules(epoll IMPORTED_TARGET epoll-shim)
if(NOT HAS_TIMERFD AND epoll_FOUND)
  target_link_libraries(aquamarine PkgConfig::epoll)
endif()

# Protocols
pkg_get_variable(WAYLAND_PROTOCOLS_DIR wayland-protocols pkgdatadir)
message(STATUS "Found wayland-protocols at ${WAYLAND_PROTOCOLS_DIR}")
pkg_get_variable(WAYLAND_SCANNER_PKGDATA_DIR wayland-scanner pkgdatadir)
message(STATUS "Found wayland-scanner pkgdatadir at ${WAYLAND_SCANNER_PKGDATA_DIR}")

function(protocolNew protoPath protoName external)
  if(external)
    set(path ${CMAKE_SOURCE_DIR}/${protoPath})
  else()
    set(path ${WAYLAND_PROTOCOLS_DIR}/${protoPath})
  endif()
  add_custom_command(
    OUTPUT ${CMAKE_SOURCE_DIR}/protocols/${protoName}.cpp
           ${CMAKE_SOURCE_DIR}/protocols/${protoName}.hpp
    COMMAND hyprwayland-scanner --client ${path}/${protoName}.xml
            ${CMAKE_SOURCE_DIR}/protocols/
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
  target_sources(aquamarine PRIVATE protocols/${protoName}.cpp
                                    protocols/${protoName}.hpp)
endfunction()
function(protocolWayland)
  add_custom_command(
    OUTPUT ${CMAKE_SOURCE_DIR}/protocols/wayland.cpp
           ${CMAKE_SOURCE_DIR}/protocols/wayland.hpp
    COMMAND hyprwayland-scanner --wayland-enums --client
            ${WAYLAND_SCANNER_PKGDATA_DIR}/wayland.xml ${CMAKE_SOURCE_DIR}/protocols/
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
  target_sources(aquamarine PRIVATE protocols/wayland.cpp protocols/wayland.hpp)
endfunction()

protocolwayland()

protocolnew("stable/xdg-shell" "xdg-shell" false)
protocolnew("stable/linux-dmabuf" "linux-dmabuf-v1" false)

# Generate hwdata info
pkg_get_variable(HWDATA_DIR hwdata pkgdatadir)
message(
  STATUS "Running ${CMAKE_SOURCE_DIR}/data/hwdata.sh < ${HWDATA_DIR}/pnp.ids")
execute_process(
  COMMAND /bin/sh -c
          "${CMAKE_SOURCE_DIR}/data/hwdata.sh < ${HWDATA_DIR}/pnp.ids"
  RESULT_VARIABLE HWDATA_PNP_RESULT
  OUTPUT_VARIABLE HWDATA_PNP_IDS ENCODING UTF8)

if(NOT HWDATA_PNP_RESULT MATCHES 0)
  message(WARNING "hwdata gathering pnps failed")
endif()

configure_file(data/hwdata.hpp.in hwdata.hpp @ONLY)

# tests
add_custom_target(tests)

add_executable(simpleWindow "tests/SimpleWindow.cpp")
target_link_libraries(simpleWindow PRIVATE PkgConfig::deps aquamarine)
add_test(
  NAME "simpleWindow"
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tests
  COMMAND simpleWindow "simpleWindow")
add_dependencies(tests simpleWindow)

add_executable(attachments "tests/Attachments.cpp")
target_link_libraries(attachments PRIVATE PkgConfig::deps aquamarine)
add_test(
  NAME "attachments"
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tests
  COMMAND attachments "attachments")
add_dependencies(tests attachments)

# Installation
install(TARGETS aquamarine)
install(DIRECTORY "include/aquamarine" DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES ${CMAKE_BINARY_DIR}/aquamarine.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== debian/changelog ===
aquamarine (0.9.5-1) unstable; urgency=medium

  * New upstream version 0.9.5

 -- Chow Loong Jin <hyperair@debian.org>  Wed, 08 Oct 2025 18:07:26 +0800

aquamarine (0.9.4-1) unstable; urgency=medium

  [ alan (NyxTrail) ]
  * Update build dep hyprutils to v0.5.2
  * Update library soversion to 7

  [ Carl Keinath ]
  * New upstream version 0.9.4
  * prepare package for team maintaining

  [ Chow Loong Jin ]
  * Bump hyprwayland-scanner build-dep version.
    0.4.4 seems to be generating empty arrays that break compilation
  * Rename packages for soname bump (7 -> 8)
  * Bump libhyprutils-dev build-dep version
  * Update uploaders
    - Add myself
    - Add commas

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 19 Sep 2025 12:06:19 +0800

aquamarine (0.8.0-1) unstable; urgency=medium

  * New upstream version 0.8.0

 -- Alan M Varghese (NyxTrail) <alan@digistorm.in>  Mon, 07 Apr 2025 14:44:21 +0000

aquamarine (0.7.2-1) unstable; urgency=medium

  * Update to latest upstream version.
  * Initial release. (Closes: #1082574)

 -- Carl Keinath <carl.keinath@gmail.com>  Fri, 07 Mar 2025 17:58:09 +0100

=== debian/control ===
Source: aquamarine
Section: libs
Priority: optional
Maintainer: Debian Hyprland Maintainers <team+hyprland@tracker.debian.org>
Uploaders:
 Alan M Varghese (NyxTrail) <alan@digistorm.in>,
 Carl Keinath <carl.keinath@gmail.com>,
 Chow Loong Jin <hyperair@debian.org>
Rules-Requires-Root: no
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 hwdata,
 hyprwayland-scanner (>= 0.4.5),
 libdisplay-info-dev,
 libdrm-dev,
 libegl-dev,
 libegl1-mesa-dev,
 libgbm-dev,
 libgles-dev,
 libhyprutils-dev (>= 0.8.0),
 libinput-dev (>= 1.26.0),
 libpixman-1-dev,
 libseat-dev (>= 0.8.0),
 libudev-dev,
 libwayland-dev,
 pkgconf,
 wayland-protocols
Standards-Version: 4.7.2
Homepage: https://wiki.hyprland.org/Hypr-Ecosystem/aquamarine/
Vcs-Browser: https://salsa.debian.org/hyprland-team/aquamarine
Vcs-Git: https://salsa.debian.org/hyprland-team/aquamarine.git

Package: libaquamarine-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libaquamarine8 (= ${binary:Version}),
 ${misc:Depends},
Description: Light-weight rendering library for Linux (development files)
 Aquamarine is a very light linux rendering backend library.
 It provides basic abstractions for an application to render on a
 Wayland session (in a window) or a native DRM session.
 .
 It is agnostic of the rendering API (Vulkan/OpenGL) and designed
 to be lightweight, performant, and minimal.
 .
 Aquamarine provides no bindings for other languages. It is 
 C++-only
 .
 This package includes the development files for aquamarine.

Package: libaquamarine8
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Light-weight rendering library for Linux (binary files)
 Aquamarine is a very light linux rendering backend library.
 It provides basic abstractions for an application to render on a
 Wayland session (in a window) or a native DRM session.
 .
 It is agnostic of the rendering API (Vulkan/OpenGL) and designed
 to be lightweight, performant, and minimal.
 .
 Aquamarine provides no bindings for other languages. It is 
 C++-only
 .
 This package includes the binaries for the aquamarine library.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_clean:
	find protocols -name '*.cpp' -exec rm -rf {} \;
	find protocols -name '*.hpp' -exec rm -rf {} \;
	dh_clean

override_dh_auto_test:
	:

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

=== debian/watch ===
Version: 5

Template: Github
Owner: hyprwm
Project: aquamarine

## aquamarine 0.10.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -66,7 +66,7 @@
   PUBLIC "./include"
   PRIVATE "./src" "./src/include" "./protocols" "${CMAKE_BINARY_DIR}")
 set_target_properties(aquamarine PROPERTIES VERSION ${AQUAMARINE_VERSION}
-                                            SOVERSION 8)
+                                            SOVERSION 9)
 target_link_libraries(aquamarine OpenGL::EGL OpenGL::OpenGL PkgConfig::deps)
 
 check_include_file("sys/timerfd.h" HAS_TIMERFD)

=== debian/changelog ===
aquamarine (0.10.0-2) unstable; urgency=medium

  * Reuplaod to unstable

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 16 Dec 2025 23:39:41 +0800

aquamarine (0.10.0-1) experimental; urgency=medium

  * New upstream version 0.10.0
  * Rename binary package for soname bump
  * d/control: Bump libhyprutils-dev build-dep version

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 01 Dec 2025 19:03:52 +0800

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
  libegl1-mesa-dev,
  libgbm-dev,
  libgles-dev,
- libhyprutils-dev (>= 0.8.0),
+ libhyprutils-dev (>= 0.10.4),
  libinput-dev (>= 1.26.0),
  libpixman-1-dev,
  libseat-dev (>= 0.8.0),
@@ -36,7 +36,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libaquamarine8 (= ${binary:Version}),
+ libaquamarine9 (= ${binary:Version}),
  ${misc:Depends},
 Description: Light-weight rendering library for Linux (development files)
  Aquamarine is a very light linux rendering backend library.
@@ -51,7 +51,7 @@
  .
  This package includes the development files for aquamarine.
 
-Package: libaquamarine8
+Package: libaquamarine9
 Architecture: any
 Multi-Arch: same
 Depends:
